/* Poniszy kod przykadowy zosta zaczerpnity z ksiki
 * "C++ Templates - The Complete Guide" autorstwa
 * Davida Vandevoorde'a i Nicolai'a M. Josuttisa, wydanej
 * w Polsce przez wydawnictwo HELION S.A. w roku 2003
 * (wydanie oryginalne: Addison-Wesley, 2002)
 *
 * (C) Copyright David Vandevoorde i Nicolai M. Josuttis 2002.
 * Kopiowanie, wykorzystanie, modyfikacja, sprzeda i
 * rozpowszechnianie tego oprogramowania jest dozwolone pod
 * warunkiem zachowania niniejszej noty o prawach autorskich
 * w kadej z wykonanych kopii.
 * Oprogramowanie to zostao udostpnione bez adnych jawnych
 * i niejawnych gwarancji; Autorzy nie gwarantuj te poprawnoci
 * dziaania niezalenie od zastosowania.
 */
#include <vector>
#include <list>
#include <stack>
#include <iostream>
#include <typeinfo>

template <typename T> 
class ElementT;                    // szablon podstawowy

template <typename T>
class ElementT<std::vector<T> > {  // specjalizacja czciowa
  public:
    typedef T Type;
};

template <typename T>
class ElementT<std::list<T> > {    // specjalizacja czciowa
  public:
    typedef T Type;
};

template <typename T>
class ElementT<std::stack<T> > {   // specjalizacja czciowa
  public:
    typedef T Type;
};

template <typename T>
void print_element_type (T const & c)
{
    std::cout << "Kontener elementw typu "
              << typeid(typename ElementT<T>::Type).name()
              << ".\n";
}

int main()
{
    std::stack<bool> s;
    print_element_type(s);
}
