/* Poniszy kod przykadowy zosta zaczerpnity z ksiki
 * "C++ Templates - The Complete Guide" autorstwa
 * Davida Vandevoorde'a i Nicolai'a M. Josuttisa, wydanej
 * w Polsce przez wydawnictwo HELION S.A. w roku 2003
 * (wydanie oryginalne: Addison-Wesley, 2002)
 *
 * (C) Copyright David Vandevoorde i Nicolai M. Josuttis 2002.
 * Kopiowanie, wykorzystanie, modyfikacja, sprzeda i
 * rozpowszechnianie tego oprogramowania jest dozwolone pod
 * warunkiem zachowania niniejszej noty o prawach autorskich
 * w kadej z wykonanych kopii.
 * Oprogramowanie to zostao udostpnione bez adnych jawnych
 * i niejawnych gwarancji; Autorzy nie gwarantuj te poprawnoci
 * dziaania niezalenie od zastosowania.
 */
#ifndef SQRT_HPP
#define SQRT_HPP

#include "ifthenelse.hpp"

// szablon generujcy argument szablonu
template<int N>
class Value {
  public:
    enum { result = N };
};

// szablon iteracyjnego obliczania pierwiastka kwadratowego z N
template <int N, int I=1>
class Sqrt {
  public:
    // konkretyzacja kolejnego kroku iteracji lub wynik w gazi typu
    typedef typename IfThenElse<(I*I<N),
                                Sqrt<N,I+1>,
                                Value<I>
                               >::ResultT
            SubT;

    // we wynik z gazi typu
    enum { result = SubT::result };
};

#endif // SQRT_HPP
